Subject: Re: bug#54646: 29.0.50; set-fontset-font and font clipping issues

From: Visuwesh <[email-masked]>
Date: Sun, 12 Jun 2022 13:17:26 +0530

[ஞாயிறு ஜூன் 12, 2022 08:53] Eli Zaretskii wrote:

>> From: Visuwesh <[email-masked]>
>> Cc: [email-masked],  [email-masked]
>> Date: Sat, 11 Jun 2022 19:24:16 +0530
>> 
>> I think this might be a cairo+pango problem.
>
> I don't see how Pango could be relevant: AFAIK we don't use any of it
> in Emacs.
>

I was under the impression that cairo used pango somewhere but,

    % ldd /usr/lib/x86_64-linux-gnu/libcairo.so.2 |grep pango

returned nothing.  However,

    % ldd $(which emacs) |grep pango
            libpangocairo-1.0.so.0 => /lib/x86_64-linux-gnu/libpangocairo-1.0.so.0 (0x00007f1c4401f000)
            libpango-1.0.so.0 => /lib/x86_64-linux-gnu/libpango-1.0.so.0 (0x00007f1c43fb9000)
            libpangoft2-1.0.so.0 => /lib/x86_64-linux-gnu/libpangoft2-1.0.so.0 (0x00007f1c4363f000)

> It could be a Cairo issue, in which case it is somewhere in the bowels
> of Cairo, not in Emacs code proper.
>
>> My suspicion is due to this bug report
>> https://github.com/harfbuzz/harfbuzz/issues/1892 -- although I don't
>> see the problem with English text as shown in the screenshots.
>
> If this is the same issue, how come you sometimes see correctly laid
> out text and sometimes incorrectly laid out text?  Emacs doesn't
> change anything in both situation, and I'm not aware of any handling
> of "hinting" on our side.

AFAIU, the issue shows itself when Emacs renders some part of the Tamil
characters and but not all.  This is a common case in eww: <hN> headers
are rendered in a slightly larger font size than the main body text.

Anyway, I don't think it is the same issue, but what I wanted to convey
by quoting that bug report is that it made suspect that the problem
might be in cairo or pango.